<?php
/* --------------------------------------------------------------
   dependent.inc.php 2016-12-13
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2016 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GM_PASSWORD_ENCRYPTION_TYPE"', true);
if($check->num_rows === 0)
{
	$query = 'INSERT INTO `gm_configuration` SET `gm_key` = "GM_PASSWORD_ENCRYPTION_TYPE", `gm_value` = "md5"';
	$t_success &= $this->query($query, true);
}

$check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GM_PASSWORD_REENCRYPT"', true);
if($check->num_rows === 0)
{
	$query = 'INSERT INTO `gm_configuration` SET `gm_key` = "GM_PASSWORD_REENCRYPT", `gm_value` = "true"';
	$t_success &= $this->query($query, true);
}

// Check if `invoice_file` column is in table invoices
$getColumns = $this->query("DESCRIBE `invoices` 'invoice_file'", true);
if($getColumns->num_rows == 0)
{
	// Add `invoice_file` column query.
	$addColumnQuery = 'ALTER TABLE `invoices` ADD `invoice_file` VARCHAR(255) NOT NULL DEFAULT \'\' AFTER `invoice_date`';
	$t_success &= $this->query($addColumnQuery);
}

$packingSlips = glob(DIR_FS_CATALOG . 'export/invoice/*.pdf')
	? : array();

foreach($packingSlips as $packingSlip)
{
	$fileName = basename($packingSlip);
	
	$check = $this->query("SELECT * FROM `invoices` WHERE `invoice_file` = '{$fileName}'", true);
	if($check->num_rows === 0)
	{
		$matchSuccess = preg_match('/^([\d]+)__(.+)?__([\d-]+)?__.*/', $fileName, $matches);
		
		if($matchSuccess === 1)
		{
			$orderId       = (int)$matches[1];
			$invoiceNumber = $matches[2];
			$invoiceDate   = $matches[3];
			
			preg_match('/([\d]+-[\d]+-[\d]+)-([\d]+-[\d]+-[\d]+)/', $invoiceDate, $invoiceDataMatches);
			$invoiceDate = $invoiceDataMatches[1] . ' ' . $invoiceDataMatches[2];
			
			$check = $this->query('SELECT `orders_id` FROM `orders` WHERE `orders_id` = ' . $orderId, true);
			if($check->num_rows === 0)
			{
				$orderId = 0;
			}
			
			$query = "INSERT INTO `invoices` SET `invoice_number` = '{$invoiceNumber}', `invoice_date` =  '{$invoiceDate}', `invoice_file` = '{$fileName}', `order_id` = {$orderId}";
			$t_success &= $this->query($query, true);
		}
	}
}


$t_success &= $this->query("CREATE TABLE IF NOT EXISTS `packing_slips` (
  `packing_slip_id` int(11) NOT NULL AUTO_INCREMENT,
  `number` varchar(255) NOT NULL DEFAULT '',
  `date` datetime NOT NULL DEFAULT '1000-01-01 00:00:00',
  `filename` varchar(255) NOT NULL DEFAULT '',
  `order_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`packing_slip_id`),
  KEY `order_id` (`order_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8", true);

$packingSlips = glob(DIR_FS_CATALOG . 'export/packingslip/*.pdf')
	? : array();

foreach($packingSlips as $packingSlip)
{
	$fileName = basename($packingSlip);
	
	$check = $this->query("SELECT * FROM `packing_slips` WHERE `filename` = '{$fileName}'", true);
	if($check->num_rows === 0)
	{
		$matchSuccess = preg_match('/^([\d]+)__([\d-]+)?__.*/', $fileName, $matches);
		
		if($matchSuccess === 1)
		{
			$orderId = (int)$matches[1];
			$date    = $matches[2];
			
			preg_match('/([\d]+-[\d]+-[\d]+)-([\d]+-[\d]+-[\d]+)/', $invoiceDate, $invoiceDataMatches);
			$invoiceDate = $invoiceDataMatches[1] . ' ' . $invoiceDataMatches[2];
			$packingSlipNumber = '';
			
			$packingSlipNumberArray = $this->query('SELECT `gm_packings_code` FROM `orders` WHERE `orders_id` = ' . (int)$orderId);
			if(!empty($packingSlipNumberArray))
			{
				$packingSlipNumber = $packingSlipNumberArray[0]['gm_packings_code'];
			}
			
			$check = $this->query('SELECT `orders_id` FROM `orders` WHERE `orders_id` = ' . $orderId, true);
			if($check->num_rows === 0)
			{
				$orderId = 0;
			}
			
			$query = "INSERT INTO `packing_slips` SET `number` = '{$packingSlipNumber}', `date` =  '{$date}', `filename` = '{$fileName}', `order_id` = {$orderId}";
			$t_success &= $this->query($query, true);
		}
	}
}


$languages = $this->query('SELECT `languages_id`, `code` FROM `languages`');
foreach($languages as $language)
{
	$pdfHeading = $language['code'] === 'de' ? 'Ihre Stornorechnung zur Rechnungsnummer {INVOICE_ID} vom {DATE}' : 'Your cancellation invoice to invoice number {INVOICE_ID} on {DATE}';
	
	/**
	 * Add Header Content
	 */
	$check = $this->query('SELECT * FROM `gm_contents` 
								WHERE `languages_id` = ' . $language['languages_id'] . ' 
									AND `gm_key` = "GM_PDF_HEADING_CANCELLATION_INVOICE"', true);
	if($check->num_rows === 0)
	{
		$query = 'INSERT INTO `gm_contents` SET `languages_id` = ' . $language['languages_id'] . ', `gm_key` = "GM_PDF_HEADING_CANCELLATION_INVOICE", `gm_value` = "' . $pdfHeading . '"';
		$t_success &= $this->query($query, true);
	}
	
	
	$pdfSubject = $language['code'] === 'de' ? 'Ihre Rechnungen zur Bestellung Nr. {ORDER_ID} vom {DATE}' : 'Your invoices of your order no. {ORDER_ID} from {DATE}';
	
	/**
	 * Add E-Mail Subject Content
	 */
	$check = $this->query('SELECT * FROM `gm_contents` 
								WHERE `languages_id` = ' . $language['languages_id'] . ' 
									AND `gm_key` = "GM_PDF_INVOICES_EMAIL_SUBJECT"', true);
	if($check->num_rows === 0)
	{
		$query = 'INSERT INTO `gm_contents` SET `languages_id` = ' . $language['languages_id'] . ', `gm_key` = "GM_PDF_INVOICES_EMAIL_SUBJECT", `gm_value` = "' . $pdfSubject . '"';
		$t_success &= $this->query($query, true);
	}
}

$t_check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GM_PDF_INVOICE_USE_CURRENT_DATE"', true);
if($t_check->num_rows === 0)
{
	$query = 'INSERT INTO `gm_configuration` SET `gm_key` = "GM_PDF_INVOICE_USE_CURRENT_DATE", `gm_value` = "1"';
	
	$t_success &= $this->query($query, true);
}

$t_check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GM_PDF_INVOICE_DATE"', true);
if($t_check->num_rows === 0)
{
	$query = 'INSERT INTO `gm_configuration` SET `gm_key` = "GM_PDF_INVOICE_DATE", `gm_value` = ""';
	
	$t_success &= $this->query($query, true);
}

$t_check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GM_PDF_PACKING_SLIP_USE_CURRENT_DATE"', true);
if($t_check->num_rows === 0)
{
	$query = 'INSERT INTO `gm_configuration` SET `gm_key` = "GM_PDF_PACKING_SLIP_USE_CURRENT_DATE", `gm_value` = "1"';
	
	$t_success &= $this->query($query, true);
}

$t_check = $this->query('SELECT * FROM `gm_configuration` WHERE `gm_key` = "GM_PDF_PACKING_SLIP_DATE"', true);
if($t_check->num_rows === 0)
{
	$query = 'INSERT INTO `gm_configuration` SET `gm_key` = "GM_PDF_PACKING_SLIP_DATE", `gm_value` = ""';
	
	$t_success &= $this->query($query, true);
}


$t_success &= $this->query("CREATE TABLE IF NOT EXISTS `documents_index` (
  `number` int(11) NOT NULL DEFAULT '0',
  `type` enum('invoice','packing_slip') NOT NULL DEFAULT 'invoice',
  `identifier` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`number`,`type`),
  KEY `identifier` (`identifier`,`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8", true);

$t_check = $this->query('SELECT * FROM `documents_index` LIMIT 1', true);
if($t_check->num_rows === 0)
{
	$query = "INSERT INTO `documents_index` (`number`, `type`, `identifier`) (SELECT
					o.`gm_orders_id`, 
					'invoice', 
					o.`gm_orders_code` 
				FROM `orders` o 
				LEFT OUTER JOIN documents_index AS i ON (o.gm_orders_id = i.number AND i.type = 'invoice') 
				WHERE
					o.gm_orders_id IS NOT NULL AND
					                      o.gm_orders_id > 0 AND
					                      i.number IS NULL
				GROUP BY o.`gm_orders_id`
			)";
	
	$t_success &= $this->query($query, true);
	
	$query = "INSERT INTO `documents_index` (`number`, `type`, `identifier`) (SELECT
					o.`gm_packings_id`, 
					'packing_slip', 
					o.`gm_packings_code` 
				FROM `orders` o 
				LEFT OUTER JOIN documents_index AS i ON (o.gm_packings_id = i.number AND i.type = 'packing_slip') 
				WHERE
					o.gm_packings_id IS NOT NULL AND
					                        o.gm_packings_id > 0 AND
					                        i.number IS NULL
				GROUP BY o.`gm_packings_id`
			)";
	
	$t_success &= $this->query($query, true);
}

$nextPackingSlipId = $this->query('SELECT `gm_value` FROM `gm_configuration` WHERE `gm_key` = "GM_NEXT_PACKINGS_ID"');
$nextPackingSlipId = (int)$nextPackingSlipId[0]['gm_value'];

$t_check = $this->query('SELECT * FROM `documents_index` WHERE `number` = ' . $nextPackingSlipId . ' AND `type` = "packing_slip"', true);
if($t_check->num_rows === 1)
{
	$nextPackingSlipId = $this->query('SELECT MAX(`number`) AS `number` FROM `documents_index` WHERE `type` = "packing_slip"');
	$nextPackingSlipId = (int)$nextPackingSlipId[0]['number'] + 1;
	
	$query = 'UPDATE `gm_configuration` SET `gm_value` = ' . $nextPackingSlipId . ' WHERE `gm_key` = "GM_NEXT_PACKINGS_ID"';
	$t_success &= is_numeric($this->query($query));
}

$nextInvoiceId = $this->query('SELECT `gm_value` FROM `gm_configuration` WHERE `gm_key` = "GM_NEXT_INVOICE_ID"');
$nextInvoiceId = (int)$nextInvoiceId[0]['gm_value'];

$t_check = $this->query('SELECT * FROM `documents_index` WHERE `number` = ' . $nextInvoiceId . ' AND `type` = "invoice"', true);
if($t_check->num_rows === 1)
{
	$nextInvoiceId = $this->query('SELECT MAX(`number`) AS `number` FROM `documents_index` WHERE `type` = "invoice"');
	$nextInvoiceId = (int)$nextInvoiceId[0]['number'] + 1;
	
	$query = 'UPDATE `gm_configuration` SET `gm_value` = ' . $nextInvoiceId . ' WHERE `gm_key` = "GM_NEXT_INVOICE_ID"';
	$t_success &= is_numeric($this->query($query));
}


/** Slider **/

$isSlideDataAlreadyImport = false;

// CREATE sliders table
$check = $this->query('SHOW TABLES LIKE "sliders"', true);
if($check->num_rows == 0)
{
	$query = "CREATE TABLE `sliders` (
				`slider_id` int(11) NOT NULL AUTO_INCREMENT,
				`name` varchar(255) NOT NULL DEFAULT '',
				`speed` decimal(5,3) unsigned NOT NULL DEFAULT 3.000,
				`start_page` tinyint(1) unsigned NOT NULL DEFAULT 0,
				PRIMARY KEY (`slider_id`)
			) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
	$t_success &= $this->query($query);
}
else
{
	$isSlideDataAlreadyImport = true;
}

// CREATE slides table
$check = $this->query('SHOW TABLES LIKE "slides"', true);
if($check->num_rows == 0)
{
	$query = "CREATE TABLE `slides` (
				  `slide_id` int(11) NOT NULL AUTO_INCREMENT,
				  `language_id` int(11) NOT NULL NOT NULL DEFAULT '0',
				  `slider_id` int(10) unsigned NOT NULL DEFAULT '0',
				  `thumbnail` varchar(255) NOT NULL DEFAULT '',
				  `title` varchar(255) NOT NULL DEFAULT '',
				  `alt_text` varchar(255) NOT NULL DEFAULT '',
				  `url` varchar(255) NOT NULL DEFAULT '',
				  `url_target` varchar(16) NOT NULL DEFAULT '_self',
				  `sort_order` int(3) NOT NULL DEFAULT '0',
				  PRIMARY KEY (`slide_id`,`language_id`)
				) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
	$t_success &= $this->query($query);
}

// CREATE slide_images table
$check = $this->query('SHOW TABLES LIKE "slide_images"', true);
if($check->num_rows == 0)
{
	$query = "CREATE TABLE `slide_images` (
				  `slide_image_id` int(11) NOT NULL AUTO_INCREMENT,
				  `slide_id` int(11) NOT NULL DEFAULT '0',
				  `language_id` int(11) NOT NULL DEFAULT '0',
				  `breakpoint` enum('xs','sm','md','lg') NOT NULL DEFAULT 'lg',
				  `image` varchar(255) NOT NULL DEFAULT '',
				  PRIMARY KEY (`slide_image_id`),
				  UNIQUE KEY `slide_image_id` (`slide_image_id`,`slide_id`,`language_id`)
				) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
	$t_success &= $this->query($query);
}

// CREATE slide_image_areas table
$check = $this->query('SHOW TABLES LIKE "slide_image_areas"', true);
if($check->num_rows == 0)
{
	$query = "CREATE TABLE `slide_image_areas` (
				  `id` int(11) NOT NULL AUTO_INCREMENT,
				  `slide_images_id` int(11) NOT NULL DEFAULT '0',
				  `coordinates` text NOT NULL,
				  `link_title` varchar(255) NOT NULL DEFAULT '',
				  `link_url` varchar(255) NOT NULL DEFAULT '',
				  `link_target` enum('_self','_blank') NOT NULL DEFAULT '_blank',
				  PRIMARY KEY (`id`),
				  KEY `fk_slide_image_maparea_slide_image1` (`slide_images_id`)
				) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
	$t_success &= $this->query($query);
}

// CREATE slider_assignments table
$check = $this->query('SHOW TABLES LIKE "slider_assignments"', true);
if($check->num_rows == 0)
{
	$query = "CREATE TABLE `slider_assignments` (
				  `slider_id` int(11) NOT NULL DEFAULT '0',
				  `entity_id` int(11) NOT NULL DEFAULT '0',
				  `entity_type` enum('category','content','product') NOT NULL DEFAULT 'category',
				  PRIMARY KEY (`entity_id`,`entity_type`)
				) ENGINE=MyISAM DEFAULT CHARSET=utf8;";
	$t_success &= $this->query($query);
}

/** Slider import **/
if(!$isSlideDataAlreadyImport)
{
	// Get TEMPLATE_PRESENTATION_VERSION
	$currentTemplate      = $this->query('SELECT `configuration_value` FROM `configuration` WHERE `configuration_key` = "CURRENT_TEMPLATE"',
	                                     true)->fetch_row();
	$templateSettingsFile = realpath(__DIR__ . '/../../../templates/' . $currentTemplate[0] . '/template_settings.php');
	preg_match('/\'TEMPLATE_PRESENTATION_VERSION.*(\d+.\d+)/', file_get_contents($templateSettingsFile), $matches);
	
	// Is template responsive?
	if((double)$matches[1] >= 3.0)
	{
		$breakpoints       = array('xs', 'sm', 'md', 'lg');
		$startPageSlider   = $this->query('SELECT `gm_value` FROM `gm_configuration` WHERE `gm_key` = "GM_SLIDER_INDEX_ID"',
		                                  true)->fetch_row();
		$startPageSliderId = (is_numeric($startPageSlider[0])
			? $startPageSlider[0]
			: null);
		
		// Insert into sliders
		$sliderSets = $this->query('SELECT * FROM `slider_set` ORDER BY `slider_set_id`', true);
		while($sliderSet = $sliderSets->fetch_assoc())
		{
			$isStartPageSlider = ($sliderSet['slider_set_id'] == $startPageSliderId)
				? 1
				: 0;
			$sliderSpeed       = ((double)$sliderSet['slider_speed'] / 1000);
			$sliderInsertQuery = 'INSERT INTO `sliders` 
									SET 
										`name` = "' . $this->real_escape_string($sliderSet['set_name']) . '",
										`speed` = "' . $sliderSpeed . '",
										`start_page`= ' . $isStartPageSlider;
			$sliderInsertId    = $this->query($sliderInsertQuery);
			$t_success &= is_numeric($sliderInsertId);
			
			//slider to category assignment
			$categorySliderAssignments = $this->query('SELECT * 
													FROM `category_slider_set` 
													WHERE `category_slider_set_id` = "' . $sliderSet['slider_set_id']
			                                          . '"', true);
			while($categorySliderAssignment = $categorySliderAssignments->fetch_assoc())
			{
				$categorySliderAssignmentInsertQuery = 'INSERT INTO `slider_assignments` 
													SET 
														`slider_id` = "' . $sliderInsertId . '",
														`entity_id` = "' . $categorySliderAssignment['category_id'] . '",
														`entity_type` = "category"';
				$t_success &= $this->query($categorySliderAssignmentInsertQuery, true);
			}
			
			//slider to product assignment
			$productSliderAssignments = $this->query('SELECT * 
													FROM `products_slider_set` 
													WHERE `slider_set_id` = "' . $sliderSet['slider_set_id'] . '"',
			                                         true);
			while($productSliderAssignment = $productSliderAssignments->fetch_assoc())
			{
				$productSliderAssignmentInsertQuery = 'INSERT INTO `slider_assignments` 
													SET 
														`slider_id` = "' . $sliderInsertId . '",
														`entity_id` = "'
				                                      . $productSliderAssignment['products_slider_set_id'] . '",
														`entity_type` = "product"';
				$t_success &= $this->query($productSliderAssignmentInsertQuery, true);
			}
			
			//slider to content assignment
			$contentSliderAssignments = $this->query('SELECT * 
													FROM `content_slider_set` 
													WHERE `slider_set_id` = "' . $sliderSet['slider_set_id'] . '"',
			                                         true);
			while($contentSliderAssignment = $contentSliderAssignments->fetch_assoc())
			{
				$contentSliderAssignmentInsertQuery = 'INSERT INTO `slider_assignments` 
													SET 
														`slider_id` = "' . $sliderInsertId . '",
														`entity_id` = "'
				                                      . $contentSliderAssignment['content_slider_set_id'] . '",
														`entity_type` = "content"';
				$t_success &= $this->query($contentSliderAssignmentInsertQuery, true);
			}
			
			// Insert into slides
			$sliderImagesQuery = 'SELECT * 
										FROM `slider_image` 
										LEFT JOIN `slider_image_description` 
										USING (`slider_image_id`) 
										WHERE `slider_set_id` = ' . $sliderSet['slider_set_id'] . ' 
										ORDER BY `slider_image`.`sort_order`, `slider_image_description`.`language_id`';
			$sliderImages      = $this->query($sliderImagesQuery, true);
			while($sliderImage = $sliderImages->fetch_assoc())
			{
				$validTargetTypes = array('_self', '_blank');
				$urlTarget        = $sliderImage['link_window_target'];
				if(!in_array($urlTarget, $validTargetTypes))
				{
					$urlTarget = $validTargetTypes[0];
				}
				
				$slideInsertQuery = 'INSERT INTO `slides` 
										SET 
											`language_id` = "' . $sliderImage['language_id'] . '",
											`slider_id` = "' . $sliderInsertId . '",
											`thumbnail` = "' . $this->real_escape_string($sliderImage['image_preview_file']) . '",
											`title` = "' . $this->real_escape_string($sliderImage['image_title']) . '",
											`alt_text` = "' . $this->real_escape_string($sliderImage['image_alt_text']) . '",
											`url` = "' . $this->real_escape_string($sliderImage['link_url']) . '",
											`url_target` = "' . $this->real_escape_string($urlTarget) . '",
											`sort_order` = "' . $sliderImage['sort_order'] . '"';
				$slideInsertId    = $this->query($slideInsertQuery);
				$t_success &= is_numeric($slideInsertId);
				
				// Insert into slide_images
				foreach($breakpoints as $breakpoint)
				{
					$slideImageInsertQuery = 'INSERT INTO `slide_images` 
												SET 
													`slide_id` = "' . $slideInsertId . '",
													`language_id` = "' . $sliderImage['language_id'] . '",
													`breakpoint` = "' . $breakpoint . '",
													`image` = "' . $this->real_escape_string($sliderImage['image_file']) . '"';
					$slideImageInsertId    = $this->query($slideImageInsertQuery);
					$t_success &= is_numeric($slideImageInsertId);
					
					// Insert into slide_image_areas
					$sliderImageAreasQuery = 'SELECT * 
											FROM `slider_image_area` 
											WHERE `slider_image_id` = ' . $sliderImage['slider_image_id'] . ' 
											ORDER BY `slider_image_area_id`';
					$sliderImageAreas      = $this->query($sliderImageAreasQuery, true);
					while($sliderImageArea = $sliderImageAreas->fetch_assoc())
					{
						if(empty($sliderImageArea['coords']))
						{
							continue;
						}
						
						switch($sliderImageArea['shape'])
						{
							case 'rect':
								$coords = explode(',', $sliderImageArea['coords']);
								$polygonCoordinates = array(
									$coords[0],
									$coords[1],
									$coords[2],
									$coords[1],
									$coords[2],
									$coords[3],
									$coords[0],
									$coords[3]
								);
								$coordinates = implode(',', $polygonCoordinates);
								break;
							case 'circle':
								$coords = explode(',', $sliderImageArea['coords']);
								$radius = $coords[2];
								$polygonCoordinates = array(
									$coords[0] - $radius,
									$coords[1] - $radius,
									$coords[0] + $radius,
									$coords[1] - $radius,
									$coords[0] + $radius,
									$coords[1] + $radius,
									$coords[0] - $radius,
									$coords[1] + $radius,
								);
								$coordinates = implode(',', $polygonCoordinates);
								break;
							default:
								$coordinates = $sliderImageArea['coords'];
						}
						
						$validTargetTypes = array('_self', '_blank');
						$urlTarget        = $sliderImageArea['link_target'];
						if(!in_array($urlTarget, $validTargetTypes))
						{
							$urlTarget = $validTargetTypes[0];
						}
						
						$slideImageAreaInsertQuery = 'INSERT INTO `slide_image_areas` 
														SET 
															`slide_images_id` = "' . $slideImageInsertId . '",
															`coordinates` = "' . $this->real_escape_string($coordinates) . '",
															`link_title` = "' . $this->real_escape_string($sliderImageArea['title']) . '",
															`link_url` = "' . $this->real_escape_string($sliderImageArea['link_url']) . '",
															`link_target` = "' . $this->real_escape_string($urlTarget) . '"';
						$t_success &= $this->query($slideImageAreaInsertQuery, true);
					}
				}
			}
		}
	}
}

// Add missing japanese country zones
$japanZoneCountryId = $this->query("SELECT countries_id FROM countries WHERE countries_name = 'Japan'");
$japanZoneCountryId = (int)$japanZoneCountryId[0]['countries_id'];

$t_success &= $this->set_index('zones', 'UNIQUE', array('zone_country_id', 'zone_code'), 'unique_country_zone');

if($japanZoneCountryId)
{
	$t_query = "DELETE FROM `zones` WHERE `zone_country_id` = $japanZoneCountryId";
	$t_success &= is_numeric($this->query($t_query));
	
	/* update ISO Codes of japanese prefectures (ISO 3166-2:JP) */
	$query = "INSERT INTO `zones` (`zone_country_id`, `zone_code`, `zone_name`) VALUES
					($japanZoneCountryId, '01', 'Hokkaido'),
					($japanZoneCountryId, '02', 'Aomori'),
					($japanZoneCountryId, '03', 'Iwate'),
					($japanZoneCountryId, '04', 'Miyagi'),
					($japanZoneCountryId, '05', 'Akita'),
					($japanZoneCountryId, '06', 'Yamagata'),
					($japanZoneCountryId, '07', 'Fukushima'),
					($japanZoneCountryId, '08', 'Ibaraki'),
					($japanZoneCountryId, '09', 'Tochigi'),
					($japanZoneCountryId, '10', 'Gunma'),
					($japanZoneCountryId, '11', 'Saitama'),
					($japanZoneCountryId, '12', 'Chiba'),
					($japanZoneCountryId, '13', 'Tokio'),
					($japanZoneCountryId, '14', 'Kanagawa'),
					($japanZoneCountryId, '15', 'Niigata'),
					($japanZoneCountryId, '16', 'Toyama'),
					($japanZoneCountryId, '17', 'Ishikawa'),
					($japanZoneCountryId, '18', 'Fukui'),
					($japanZoneCountryId, '19', 'Yamanashi'),
					($japanZoneCountryId, '20', 'Nagano'),
					($japanZoneCountryId, '21', 'Gifu'),
					($japanZoneCountryId, '22', 'Shizuoka'),
					($japanZoneCountryId, '23', 'Aichi'),
					($japanZoneCountryId, '24', 'Mie'),
					($japanZoneCountryId, '25', 'Shiga'),
					($japanZoneCountryId, '26', 'Kyoto'),
					($japanZoneCountryId, '27', 'Osaka'),
					($japanZoneCountryId, '28', 'Hyogo'),
					($japanZoneCountryId, '29', 'Nara'),
					($japanZoneCountryId, '30', 'Wakayama'),
					($japanZoneCountryId, '31', 'Tottori'),
					($japanZoneCountryId, '32', 'Shimane'),
					($japanZoneCountryId, '33', 'Okayama'),
					($japanZoneCountryId, '34', 'Hiroshima'),
					($japanZoneCountryId, '35', 'Yamaguchi'),
					($japanZoneCountryId, '36', 'Tokushima'),
					($japanZoneCountryId, '37', 'Kagawa'),
					($japanZoneCountryId, '38', 'Ehime'),
					($japanZoneCountryId, '39', 'Kochi'),
					($japanZoneCountryId, '40', 'Fukuoka'),
					($japanZoneCountryId, '41', 'Saga'),
					($japanZoneCountryId, '42', 'Nagasaki'),
					($japanZoneCountryId, '43', 'Kumamoto'),
					($japanZoneCountryId, '44', 'Oita'),
					($japanZoneCountryId, '45', 'Miyazaki'),
					($japanZoneCountryId, '46', 'Kagoshima'),
					($japanZoneCountryId, '47', 'Okinawa')";
	$t_success &= $this->query($query, true);
}

$check = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "SESSION_TIMEOUT"', true);
if($check->num_rows === 0)
{
	$query = 'INSERT INTO `configuration` 
				SET configuration_key = "SESSION_TIMEOUT", 
					configuration_value = "24",
					configuration_group_id = "15",
					sort_order = "8"';
	$t_success &= $this->query($query, true);
}

/**
 * set unique index for countries_iso_code_2 and countries_iso_code_3 in countries table
 */
$t_success &= $this->set_index('countries', 'UNIQUE', array('countries_iso_code_2'), 'countries_iso_code_2');
$t_success &= $this->set_index('countries', 'UNIQUE', array('countries_iso_code_3'), 'countries_iso_code_3');

/**
 * Insert the configuration for the mandatory field 'housenumber'
 */
$check = $this->query('SELECT * FROM `configuration` WHERE `configuration_key` = "ENTRY_HOUSENUMBER_MIN_LENGTH"', true);
if($check->num_rows === 0)
{
	$query = 'INSERT INTO `configuration` 
				SET configuration_key = "ENTRY_HOUSENUMBER_MIN_LENGTH", 
					configuration_value = "1",
					configuration_group_id = "2",
					sort_order = "5"';
	$t_success &= $this->query($query, true);
}

/**
 * Insert new countries into countries table if they did not exist
 */

$newCountries = array(
	'AX' => array(
		'name' => 'Åland Islands',
		'iso2' => 'AX',
		'iso3' => 'ALA',
		'address_format_id' => '1',
		'status' => '0'
	),
	'BL' => array(
		'name' => 'Saint Barthélemy',
		'iso2' => 'BL',
		'iso3' => 'BLM',
		'address_format_id' => '1',
		'status' => '0'
	),
	'BQ' => array(
		'name' => 'Bonaire, Sint Eustatius and Saba',
		'iso2' => 'BQ',
		'iso3' => 'BES',
		'address_format_id' => '1',
		'status' => '0'
	),
	'CD' => array(
		'name' => 'Congo (the Democratic Republic of the)',
		'iso2' => 'CD',
		'iso3' => 'COD',
		'address_format_id' => '1',
		'status' => '0'
	),
	'CW' => array(
		'name' => 'Curaçao',
		'iso2' => 'CW',
		'iso3' => 'CUW',
		'address_format_id' => '1',
		'status' => '0'
	),
	'GG' => array(
		'name' => 'Guernsey',
		'iso2' => 'GG',
		'iso3' => 'GGY',
		'address_format_id' => '1',
		'status' => '0'
	),
	'IM' => array(
		'name' => 'Isle of Man',
		'iso2' => 'IM',
		'iso3' => 'IMN',
		'address_format_id' => '1',
		'status' => '0'
	),
	'JE' => array(
		'name' => 'Jersey',
		'iso2' => 'JE',
		'iso3' => 'JEY',
		'address_format_id' => '1',
		'status' => '0'
	),
	'ME' => array(
		'name' => 'Montenegro',
		'iso2' => 'ME',
		'iso3' => 'MNE',
		'address_format_id' => '1',
		'status' => '0'
	),
	'MF' => array(
		'name' => 'Saint Martin (French part)',
		'iso2' => 'MF',
		'iso3' => 'MAF',
		'address_format_id' => '1',
		'status' => '0'
	),
	'PS' => array(
		'name' => 'Palestine, State of',
		'iso2' => 'PS',
		'iso3' => 'PSE',
		'address_format_id' => '1',
		'status' => '0'
	),
	'SS' => array(
		'name' => 'South Sudan',
		'iso2' => 'SS',
		'iso3' => 'SSD',
		'address_format_id' => '1',
		'status' => '0'
	),
	'SX' => array(
		'name' => 'Sint Maarten (Dutch part)',
		'iso2' => 'SX',
		'iso3' => 'SXM',
		'address_format_id' => '1',
		'status' => '0'
	),
	'TL' => array(
		'name' => 'Timor-Leste',
		'iso2' => 'TL',
		'iso3' => 'TLS',
		'address_format_id' => '1',
		'status' => '0'
	)
);

foreach($newCountries as $newCountryCode => $newCountry) 
{
	$select = 'SELECT * FROM `countries` WHERE `countries_iso_code_2` = "'. $newCountryCode.'"';
	$check = $this->query($select, true);
	if($check->num_rows === 0)
	{
		$query = 'INSERT INTO `countries` 
				  SET `countries_name` = "' . $newCountry['name'] . '",
					  `countries_iso_code_2` = "' . $newCountry['iso2'] . '",
					  `countries_iso_code_3` = "' . $newCountry['iso3'] . '",
					  `address_format_id` = ' . $newCountry['address_format_id'] . ',
					  `status` = ' . $newCountry['status'];
		$t_success &= $this->query($query, true);
	}
}